# include <iostream>
# include <vector>
using namespace std;

const int MAX=1e2+11;
vector<int> a[MAX];
int parrent[MAX];
long long pd[MAX];
long long w[MAX];
int n,k;

void Read()
{
    cin>>n>>k;
    k++;
    for(int i=1; i<=n; i++)
    {
        int v, W, d;
        cin>>W>>v>>d;

        a[v].push_back(i);
        a[i].push_back(v);
        parrent[i]=v;
        pd[i]=d;
        w[i]=W;
    }
}

long long dist[MAX][MAX];
int vis[MAX];
int TM=0;

void dfs1(int start, int curr, long long d)
{
    dist[start][curr]=d;
    vis[curr]=TM;
    for(int nxt: a[curr])
    {
        if(vis[nxt]==TM) continue;
        if(parrent[curr]==nxt) dfs1(start,nxt,d+pd[curr]);
        else dfs1(start,nxt,d+pd[nxt]);
    }
}

void get_dist()
{
    for(int i=0; i<=n; i++)
    {
        TM++;
        dfs1(i,i,0);
        //for(int j=0;j<=n;j++) cout<<i<<"->"<<j<<" "<<dist[i][j]<<"\n";
    }
}

const long long INF=1e18;
bool used[MAX];
long long dp[MAX][MAX];

void reset_dp()
{
    for(int i=1; i<=n; i++)
    {
        for(int j=0; j<=k; j++)
        {
            dp[i][j]=INF;
        }
    }
}

long long range[MAX][MAX];

void precomp()
{
    for(int l=0;l<=n;l++)
    {
        for(int r=l;r<=n;r++)
        {
            long long ans=0;
            for(int i=l;i<=r;i++) ans+=dist[i][r]*w[i];

            range[l][r]=ans;
        }
    }
}

void Solve()
{
    get_dist();
    precomp();
    reset_dp();

    long long ans=INF;
    for(int i=1;i<=n;i++)
    {
        for(int c=1;c<=k;c++)
        {
            for(int last=i;last>=0;last--)
            {
                if(last==0) dp[i][c]=min(dp[i][c],range[last][i]);
                else if(c==1) dp[i][c]=min(dp[i][c],range[0][i]);
                else dp[i][c]=min(dp[i][c],dp[last-1][c-1]+range[last][i]);

                if(i==n) ans=min(ans,dp[i][c]);
            }
        }
    }

    cout<<ans<<"\n";

}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    Read();
    Solve();

    return 0;
}



