#include <bits/stdc++.h>
#include "segment.h"
using namespace std;

const int MAXVALUE = 2 * 1e9;
const int MAXSQRT = sqrt(MAXVALUE) + 1;
const int MAXN = 3 * 1e6 + 1;
bool IsPrime[MAXSQRT];
std :: vector<int> Primes;
std :: vector<int> Positions[MAXN];
std :: unordered_map<int, int> Decode;
std :: vector<int> Divisors;
int Code;

void Sieve()
{
    IsPrime[0] = true;
    IsPrime[1] = true;

    for(int i = 1; i < MAXSQRT; i++)
    {
        if(IsPrime[i]) continue;
        Primes.push_back(i);

        for(long long j = i * i; j < MAXSQRT; j += i)
        {
            IsPrime[j] = true;
        }
    }
}

long long max_segment(std :: vector<int> A)
{
    ///Sieve();
    Primes.push_back(2);

    for(int i = 0; i < (int)A.size(); i++)
    {
        int Copy = A[i];

        for(int j = 0; j < (int)Primes.size() && Primes[j] * Primes[j] <= Copy; j++)
        {
            if(Copy % Primes[j] != 0)
            {
                continue;
            }

            int Hybrid = 1;

            while(Copy % Primes[j] == 0)
            {
                Hybrid *= Primes[j];
                Copy /= Primes[j];

                if(Decode[Hybrid] == 0)
                {
                    Code++;
                    Decode[Hybrid] = Code;
                    Divisors.push_back(Hybrid);
                }

                Positions[Decode[Hybrid]].push_back(i);
            }

            break;
        }

        if(Copy != 1)
        {
            if(Decode[Copy] == 0)
            {
                Code++;
                Decode[Copy] = Code;
                Divisors.push_back(Copy);
            }

            Positions[Decode[Copy]].push_back(i);
        }
    }

    long long Answer = (int)A.size();

    for(auto& Div : Divisors)
    {
        int Index = Decode[Div];
        int Previous = -1;
        int Gcd = 1e9;
        int Streak = 0;

        for(auto& i : Positions[Index])
        {
            if(Previous == -1 || i - Previous == 1)
            {
                Gcd = min(Gcd, A[i]);
                Streak++;
            }
            else
            {
                Gcd = (A[i]);
                Streak = 1;
            }

            Previous = i;
            Answer = max(Answer, (long long)(Streak) * (long long)(Gcd));
        }
    }

    return Answer;
}