#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 3e6 + 10;
const int MAXLOG = 24;

ll st[MAXN][MAXLOG];
ll a[MAXN];
ll lg[MAXN];
ll n;

void fill_st()
{
    for(int i = 1; i <= n; i++)
    {
        st[i][0] = a[i];
    }

    for(int j = 1; j < MAXLOG; j++)
    {
        for(int i = 1; i + (1 << j) - 1<= n; i++)
        {
            st[i][j] = __gcd(st[i][j - 1], st[i + (1 << (j - 1))][j - 1]);
        }
    }

    for(int i = 2; i <= n; i++)
    {
        lg[i] = lg[i / 2] + 1;
    }
}

ll query(int left, int right)
{
    int len = right - left + 1;
    int k = lg[len];

    return __gcd(st[left][k], st[right - (1 << k) + 1][k]);
}

ll solve()
{
    ll ans = 0;
    pair < int, int > p;
    for(int left = 1; left <= n; left++)
    {
        for(int right = left; right <= n; right++)
        {
            int len = right - left + 1;
            ll cost = len * query(left, right);
            if(ans < cost)
            {
                ans = cost;
                p = {left, right};
            }
        }
    }

    return ans;
}

ll solve_prime()
{
    ll ans = 0;
    ll cnt = 1;

    for(int i = 2; i <= n; i++)
    {
        if(a[i] != a[i - 1])
        {
            ans = max(ans, a[i - 1] * cnt);
            cnt = 1;
        }
        else cnt++;
    }
    ans = max(ans, a[n] * cnt);

    return ans;
}

bool is2(int x)
{
    while(x != 1)
    {
        if(x % 2 == 1)
            return false;
        x /= 2;
    }
    return true;
}

ll solve2()
{
    ll maxel = 0;

    for(int i = 1; i <= n; i++)
    {
        maxel = max(maxel, a[i]);
    }

    ll ans = n;
    ll g = 1;
    for(int p = 1; p <= 32 && 2 * g <= maxel; p++)
    {
        g *= 2;
        ll len = 0;
        ll maxlen = 0;

        for(int i = 1; i <= n; i++)
        {
            if(a[i] % g == 0)
                len++;
            else
            {
                maxlen = max(maxlen, len);
                len = 0;
            }
        }
        maxlen = max(maxlen, len);

        ans = max(ans, g * maxlen);
    }

    return ans;
}

ll max_segment(vector<int> A)
{
    n = A.size();
    bool lampa2 = true;
    for(int i = 0; i < n; i++)
    {
        a[i + 1] = A[i];
        if(!is2(a[i + 1]))
            lampa2 = false;
    }

    if(lampa2)
        return solve2();

    if(n > 500)
        return solve_prime();
    

    fill_st();
    return solve();
}